//+-------------------------------------------------------------------+
//|                                            Bollinger Bands %b.mq4 |
//|                       Copyright  2004, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.net |
//|                                     Modified by Alejandro Galindo |
//|                                                                   |
//|                                            You are free to use it |
//|                                                                   |
//|       If you want and if this work/modification is helpful to you |
//|              you can send me a PayPal donation to ag@elcactus.com |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
//---- input parameters
extern int TimeFrame = 0;
extern int BBPeriod=20;
extern int StdDeviation=2;
//---- buffers
double BLGBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BLGBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="BBpB("+BBPeriod+","+StdDeviation+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   TimeFrame = MathMax(TimeFrame,Period());
   SetIndexDrawBegin(0,BBPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMax(MathMin(Bars-countedBars,Bars-1),3*TimeFrame/Period());

   for(i=limit; i>=0; i--)
   {
      int    y    = iBarShift(NULL,TimeFrame,Time[i]);
      double diff = (iBands(NULL,TimeFrame,BBPeriod,StdDeviation,0,PRICE_CLOSE,MODE_UPPER,y)-iBands(NULL,TimeFrame,BBPeriod,StdDeviation,0,PRICE_CLOSE,MODE_LOWER,y))/2.0;
         if (diff != 0)
               BLGBuffer[i]=100*(iClose(NULL,TimeFrame,y)-iMA(NULL,TimeFrame,BBPeriod,0,MODE_SMA,PRICE_CLOSE,y))/diff;
         else  BLGBuffer[i]=0;
   }
   return(0);
  }
//+------------------------------------------------------------------+